public static interface ExtensionChain.ExtensionOrBuilder extends MessageOrBuilderImplements
MessageOrBuilderMethods
getAuthority()
public abstract String getAuthority() Optional. The :authority header in the gRPC request sent from Envoy
to the extension service.
Required for Callout extensions.
This field is not supported for plugin extensions. Setting it results in a validation error.
string authority = 2 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
String |
The authority. |
getAuthorityBytes()
public abstract ByteString getAuthorityBytes() Optional. The :authority header in the gRPC request sent from Envoy
to the extension service.
Required for Callout extensions.
This field is not supported for plugin extensions. Setting it results in a validation error.
string authority = 2 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
ByteString |
The bytes for authority. |
getFailOpen()
public abstract boolean getFailOpen()Optional. Determines how the proxy behaves if the call to the extension fails or times out.
When set to TRUE, request or response processing continues without
error. Any subsequent extensions in the extension chain are also
executed. When set to FALSE or the default setting of FALSE is used,
one of the following happens:
If response headers have not been delivered to the downstream client, a generic 500 error is returned to the client. The error response can be tailored by configuring a custom error response in the load balancer.
If response headers have been delivered, then the HTTP stream to the downstream client is reset.
bool fail_open = 6 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
boolean |
The failOpen. |
getForwardAttributes(int index)
public abstract String getForwardAttributes(int index) Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributes field (of type
map<string, google.protobuf.Struct>), where the keys are the attribute
names. Refer to the
documentation
for the names of attributes that can be forwarded. If omitted, no
attributes are sent. Each element is a string indicating the
attribute name.
repeated string forward_attributes = 8 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the element to return. |
| Returns | |
|---|---|
| Type | Description |
String |
The forwardAttributes at the given index. |
getForwardAttributesBytes(int index)
public abstract ByteString getForwardAttributesBytes(int index) Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributes field (of type
map<string, google.protobuf.Struct>), where the keys are the attribute
names. Refer to the
documentation
for the names of attributes that can be forwarded. If omitted, no
attributes are sent. Each element is a string indicating the
attribute name.
repeated string forward_attributes = 8 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the value to return. |
| Returns | |
|---|---|
| Type | Description |
ByteString |
The bytes of the forwardAttributes at the given index. |
getForwardAttributesCount()
public abstract int getForwardAttributesCount() Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributes field (of type
map<string, google.protobuf.Struct>), where the keys are the attribute
names. Refer to the
documentation
for the names of attributes that can be forwarded. If omitted, no
attributes are sent. Each element is a string indicating the
attribute name.
repeated string forward_attributes = 8 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
int |
The count of forwardAttributes. |
getForwardAttributesList()
public abstract List<String> getForwardAttributesList() Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributes field (of type
map<string, google.protobuf.Struct>), where the keys are the attribute
names. Refer to the
documentation
for the names of attributes that can be forwarded. If omitted, no
attributes are sent. Each element is a string indicating the
attribute name.
repeated string forward_attributes = 8 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
List<String> |
A list containing the forwardAttributes. |
getForwardHeaders(int index)
public abstract String getForwardHeaders(int index)Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
repeated string forward_headers = 7 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the element to return. |
| Returns | |
|---|---|
| Type | Description |
String |
The forwardHeaders at the given index. |
getForwardHeadersBytes(int index)
public abstract ByteString getForwardHeadersBytes(int index)Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
repeated string forward_headers = 7 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the value to return. |
| Returns | |
|---|---|
| Type | Description |
ByteString |
The bytes of the forwardHeaders at the given index. |
getForwardHeadersCount()
public abstract int getForwardHeadersCount()Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
repeated string forward_headers = 7 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
int |
The count of forwardHeaders. |
getForwardHeadersList()
public abstract List<String> getForwardHeadersList()Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
repeated string forward_headers = 7 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
List<String> |
A list containing the forwardHeaders. |
getMetadata()
public abstract Struct getMetadata() Optional. The metadata provided here is included as part of the
metadata_context (of type google.protobuf.Struct) in the
ProcessingRequest message sent to the extension server.
For AuthzExtension resources, the metadata is available under the
namespace com.google.authz_extension.<resource_name>.
For other types of extensions, the metadata is available under the
namespace
com.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>.
For example:
com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.
The following variables are supported in the metadata:
{forwarding_rule_id} - substituted with the forwarding rule's fully
qualified resource name.
This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
.google.protobuf.Struct metadata = 9 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
Struct |
The metadata. |
getMetadataOrBuilder()
public abstract StructOrBuilder getMetadataOrBuilder() Optional. The metadata provided here is included as part of the
metadata_context (of type google.protobuf.Struct) in the
ProcessingRequest message sent to the extension server.
For AuthzExtension resources, the metadata is available under the
namespace com.google.authz_extension.<resource_name>.
For other types of extensions, the metadata is available under the
namespace
com.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>.
For example:
com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.
The following variables are supported in the metadata:
{forwarding_rule_id} - substituted with the forwarding rule's fully
qualified resource name.
This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
.google.protobuf.Struct metadata = 9 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
StructOrBuilder |
|
getName()
public abstract String getName()Optional. The name for this extension. The name is logged as part of the HTTP request logs. The name must conform with RFC-1034, is restricted to lower-cased letters, numbers and hyphens, and can have a maximum length of 63 characters. Additionally, the first character must be a letter and the last a letter or a number.
This field is required except for AuthzExtension.
string name = 1 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
String |
The name. |
getNameBytes()
public abstract ByteString getNameBytes()Optional. The name for this extension. The name is logged as part of the HTTP request logs. The name must conform with RFC-1034, is restricted to lower-cased letters, numbers and hyphens, and can have a maximum length of 63 characters. Additionally, the first character must be a letter and the last a letter or a number.
This field is required except for AuthzExtension.
string name = 1 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
ByteString |
The bytes for name. |
getObservabilityMode()
public abstract boolean getObservabilityMode() Optional. When set to true, the calls to the extension backend are
performed asynchronously, without pausing the processing of the ongoing
request. In this mode, only STREAMED (default) body processing is
supported. Responses, if any, are ignored.
Supported by regional LbTrafficExtension and LbRouteExtension
resources.
bool observability_mode = 16 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
boolean |
The observabilityMode. |
getRequestBodySendMode()
public abstract BodySendMode getRequestBodySendMode()Optional. Configures the send mode for request body processing.
The field can only be set if supported_events includes REQUEST_BODY.
If supported_events includes REQUEST_BODY,
but request_body_send_mode is unset, the default value STREAMED is
used.
When this field is set to FULL_DUPLEX_STREAMED, supported_events
must include both REQUEST_BODY and REQUEST_TRAILERS.
This field can be set only for LbTrafficExtension and
LbRouteExtension resources, and only when the service field of the
extension points to a BackendService. Only FULL_DUPLEX_STREAMED mode
is supported for LbRouteExtension resources.
.google.cloud.networkservices.v1.BodySendMode request_body_send_mode = 14 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
BodySendMode |
The requestBodySendMode. |
getRequestBodySendModeValue()
public abstract int getRequestBodySendModeValue()Optional. Configures the send mode for request body processing.
The field can only be set if supported_events includes REQUEST_BODY.
If supported_events includes REQUEST_BODY,
but request_body_send_mode is unset, the default value STREAMED is
used.
When this field is set to FULL_DUPLEX_STREAMED, supported_events
must include both REQUEST_BODY and REQUEST_TRAILERS.
This field can be set only for LbTrafficExtension and
LbRouteExtension resources, and only when the service field of the
extension points to a BackendService. Only FULL_DUPLEX_STREAMED mode
is supported for LbRouteExtension resources.
.google.cloud.networkservices.v1.BodySendMode request_body_send_mode = 14 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
int |
The enum numeric value on the wire for requestBodySendMode. |
getResponseBodySendMode()
public abstract BodySendMode getResponseBodySendMode() Optional. Configures the send mode for response processing. If
unspecified, the default value STREAMED is used.
The field can only be set if supported_events includes RESPONSE_BODY.
If supported_events includes RESPONSE_BODY, but
response_body_send_mode is unset, the default value STREAMED is used.
When this field is set to FULL_DUPLEX_STREAMED, supported_events
must include both RESPONSE_BODY and RESPONSE_TRAILERS.
This field can be set only for LbTrafficExtension resources, and only
when the service field of the extension points to a BackendService.
.google.cloud.networkservices.v1.BodySendMode response_body_send_mode = 15 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
BodySendMode |
The responseBodySendMode. |
getResponseBodySendModeValue()
public abstract int getResponseBodySendModeValue() Optional. Configures the send mode for response processing. If
unspecified, the default value STREAMED is used.
The field can only be set if supported_events includes RESPONSE_BODY.
If supported_events includes RESPONSE_BODY, but
response_body_send_mode is unset, the default value STREAMED is used.
When this field is set to FULL_DUPLEX_STREAMED, supported_events
must include both RESPONSE_BODY and RESPONSE_TRAILERS.
This field can be set only for LbTrafficExtension resources, and only
when the service field of the extension points to a BackendService.
.google.cloud.networkservices.v1.BodySendMode response_body_send_mode = 15 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
int |
The enum numeric value on the wire for responseBodySendMode. |
getService()
public abstract String getService()Required. The reference to the service that runs the extension.
To configure a callout extension, service must be a fully-qualified
reference
to a backend
service
in the format:
https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}
or
https://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}.
To configure a plugin extension, service must be a reference
to a WasmPlugin
resource
in the format:
projects/{project}/locations/{location}/wasmPlugins/{plugin}
or
//networkservices.googleapis.com/projects/{project}/locations/{location}/wasmPlugins/{wasmPlugin}.
Plugin extensions are currently supported for the
LbTrafficExtension, the LbRouteExtension, and the LbEdgeExtension
resources.
string service = 3 [(.google.api.field_behavior) = REQUIRED];
| Returns | |
|---|---|
| Type | Description |
String |
The service. |
getServiceBytes()
public abstract ByteString getServiceBytes()Required. The reference to the service that runs the extension.
To configure a callout extension, service must be a fully-qualified
reference
to a backend
service
in the format:
https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}
or
https://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}.
To configure a plugin extension, service must be a reference
to a WasmPlugin
resource
in the format:
projects/{project}/locations/{location}/wasmPlugins/{plugin}
or
//networkservices.googleapis.com/projects/{project}/locations/{location}/wasmPlugins/{wasmPlugin}.
Plugin extensions are currently supported for the
LbTrafficExtension, the LbRouteExtension, and the LbEdgeExtension
resources.
string service = 3 [(.google.api.field_behavior) = REQUIRED];
| Returns | |
|---|---|
| Type | Description |
ByteString |
The bytes for service. |
getSupportedEvents(int index)
public abstract EventType getSupportedEvents(int index)Optional. A set of events during request or response processing for which this extension is called.
For the LbTrafficExtension resource, this field is required.
For the LbRouteExtension resource, this field is optional. If
unspecified, REQUEST_HEADERS event is assumed as supported.
For the LbEdgeExtension resource, this field is required and must only
contain REQUEST_HEADERS event.
For the AuthzExtension resource, this field is optional.
REQUEST_HEADERS is the only supported event. If unspecified,
REQUEST_HEADERS event is assumed as supported.
repeated .google.cloud.networkservices.v1.EventType supported_events = 4 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the element to return. |
| Returns | |
|---|---|
| Type | Description |
EventType |
The supportedEvents at the given index. |
getSupportedEventsCount()
public abstract int getSupportedEventsCount()Optional. A set of events during request or response processing for which this extension is called.
For the LbTrafficExtension resource, this field is required.
For the LbRouteExtension resource, this field is optional. If
unspecified, REQUEST_HEADERS event is assumed as supported.
For the LbEdgeExtension resource, this field is required and must only
contain REQUEST_HEADERS event.
For the AuthzExtension resource, this field is optional.
REQUEST_HEADERS is the only supported event. If unspecified,
REQUEST_HEADERS event is assumed as supported.
repeated .google.cloud.networkservices.v1.EventType supported_events = 4 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
int |
The count of supportedEvents. |
getSupportedEventsList()
public abstract List<EventType> getSupportedEventsList()Optional. A set of events during request or response processing for which this extension is called.
For the LbTrafficExtension resource, this field is required.
For the LbRouteExtension resource, this field is optional. If
unspecified, REQUEST_HEADERS event is assumed as supported.
For the LbEdgeExtension resource, this field is required and must only
contain REQUEST_HEADERS event.
For the AuthzExtension resource, this field is optional.
REQUEST_HEADERS is the only supported event. If unspecified,
REQUEST_HEADERS event is assumed as supported.
repeated .google.cloud.networkservices.v1.EventType supported_events = 4 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
List<EventType> |
A list containing the supportedEvents. |
getSupportedEventsValue(int index)
public abstract int getSupportedEventsValue(int index)Optional. A set of events during request or response processing for which this extension is called.
For the LbTrafficExtension resource, this field is required.
For the LbRouteExtension resource, this field is optional. If
unspecified, REQUEST_HEADERS event is assumed as supported.
For the LbEdgeExtension resource, this field is required and must only
contain REQUEST_HEADERS event.
For the AuthzExtension resource, this field is optional.
REQUEST_HEADERS is the only supported event. If unspecified,
REQUEST_HEADERS event is assumed as supported.
repeated .google.cloud.networkservices.v1.EventType supported_events = 4 [(.google.api.field_behavior) = OPTIONAL];
| Parameter | |
|---|---|
| Name | Description |
index |
intThe index of the value to return. |
| Returns | |
|---|---|
| Type | Description |
int |
The enum numeric value on the wire of supportedEvents at the given index. |
getSupportedEventsValueList()
public abstract List<Integer> getSupportedEventsValueList()Optional. A set of events during request or response processing for which this extension is called.
For the LbTrafficExtension resource, this field is required.
For the LbRouteExtension resource, this field is optional. If
unspecified, REQUEST_HEADERS event is assumed as supported.
For the LbEdgeExtension resource, this field is required and must only
contain REQUEST_HEADERS event.
For the AuthzExtension resource, this field is optional.
REQUEST_HEADERS is the only supported event. If unspecified,
REQUEST_HEADERS event is assumed as supported.
repeated .google.cloud.networkservices.v1.EventType supported_events = 4 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
List<Integer> |
A list containing the enum numeric values on the wire for supportedEvents. |
getTimeout()
public abstract Duration getTimeout() Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between 10-10000 milliseconds. Required
for callout extensions.
This field is not supported for plugin extensions. Setting it results in a validation error.
.google.protobuf.Duration timeout = 5 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
Duration |
The timeout. |
getTimeoutOrBuilder()
public abstract DurationOrBuilder getTimeoutOrBuilder() Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between 10-10000 milliseconds. Required
for callout extensions.
This field is not supported for plugin extensions. Setting it results in a validation error.
.google.protobuf.Duration timeout = 5 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
DurationOrBuilder |
|
hasMetadata()
public abstract boolean hasMetadata() Optional. The metadata provided here is included as part of the
metadata_context (of type google.protobuf.Struct) in the
ProcessingRequest message sent to the extension server.
For AuthzExtension resources, the metadata is available under the
namespace com.google.authz_extension.<resource_name>.
For other types of extensions, the metadata is available under the
namespace
com.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>.
For example:
com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.
The following variables are supported in the metadata:
{forwarding_rule_id} - substituted with the forwarding rule's fully
qualified resource name.
This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
.google.protobuf.Struct metadata = 9 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
boolean |
Whether the metadata field is set. |
hasTimeout()
public abstract boolean hasTimeout() Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between 10-10000 milliseconds. Required
for callout extensions.
This field is not supported for plugin extensions. Setting it results in a validation error.
.google.protobuf.Duration timeout = 5 [(.google.api.field_behavior) = OPTIONAL];
| Returns | |
|---|---|
| Type | Description |
boolean |
Whether the timeout field is set. |